#include <cstdio>
#include <cstdlib>
#include <image.h>
#include <misc.h>
#include <pnmfile.h>
#include "CImageSegmentationIndexFile.h"
#include "segment-image.h"
#include <iostream>

#include <dirent.h>
#include <regex.h>

using namespace std;

static regex_t regexpr;
int search (const struct dirent* dp) {
  if (regexec(&regexpr, dp->d_name, 0, NULL, 0) == 0)
    return 1;
  else
    return 0;
}

int main(int argc, char **argv) {
  if (argc != 4) {
    fprintf(stderr, "usage: %s sigma k min \n", argv[0]);
    return 1;
  }
  clock_t totaltimerStart, totaltimerEnd;
  totaltimerStart = clock();

  float sigma = atof(argv[1]);
  float k = atof(argv[2]);
  int min_size = atoi(argv[3]);

  struct dirent **namelist;
  int n;

  regcomp(&regexpr,".png$", REG_EXTENDED);

  if ((n = scandir(".", &namelist, search, alphasort)) < 0) {
    std::cerr << "could not read directory" << std::endl;
    exit(-1);
  };

  for (int i = 0; i < n; i++) {

  printf("loading input image.\n");
  //image<rgb> *input = loadPNG(argv[4]);
  image<rgb> *input = loadPNG(namelist[i]->d_name);
	
  printf("processing\n");
  int num_ccs; 
  long int bsi[input->width() * input->height()];
  image<rgb> *seg = segment_image(input, sigma, k, min_size, &num_ccs, bsi); 
//   savePPM(seg, argv[5]);
  char buffer [200];
  size_t length =   strlen(namelist[i]->d_name);
  strncpy(buffer, namelist[i]->d_name, length);
  strcpy(&(buffer[length-3]), "bsi");


CImageSegmentationIndexFile::Save(buffer, input->width(), input->height(), bsi);

  printf("got %d components\n", num_ccs);
  printf("done! uff...thats hard work.\n");

}

  totaltimerEnd = clock();
  std::cout << "time: " << ((double)(totaltimerEnd - totaltimerStart))/CLOCKS_PER_SEC << " seconds" << std::endl << std::flush;

  return 0;

}

